<script lang="ts">
  import { getContext, onMount } from "svelte";
  import Feature from "$lib/components/Feature.svelte";
  import AmeOutput from "$lib/components/AmeOutput.svelte";

  function updateFeatureColours(isDark: bool): [string, string, string] {
    let onyxFeatureColour = isDark ? "#cba6f7" : "#8839ef";
    let btrfsFeatureColour = isDark ? "#f5e0dc" : "#dc8a78";
    let ameFeatureColour = isDark ? "#f38ba8" : "#d20f39";
    return [onyxFeatureColour, btrfsFeatureColour, ameFeatureColour];
  }

  var description = [
    "Crystal Linux is an Arch Linux based distribution.",
    "Friendly, powerful, and easy to use."
  ].join("");

  let isDark = false;
  let [onyxFeatureColour, btrfsFeatureColour, ameFeatureColour] = updateFeatureColours(isDark);
  onMount(() => {
    isDark = window.matchMedia('(prefers-color-scheme: dark)').matches;
    [onyxFeatureColour, btrfsFeatureColour, ameFeatureColour] = updateFeatureColours(isDark);
    window.matchMedia('(prefers-color-scheme: dark)').addEventListener('change', event => {
      isDark = event.matches;
      [onyxFeatureColour, btrfsFeatureColour, ameFeatureColour] = updateFeatureColours(isDark);
    });
  });
</script>

<svelte:head>
  <title>Crystal Linux</title>
  <meta name="description" content="Crystal Linux is an Arch Linux based distribution" />
  <meta property="og:title" content="Crystal Linux"/>
  <meta property="og:type" content="website"/>
  <meta property="og:description" content={description}/>
  <meta property="og:image" content="/embed.png"/>
  <meta property="og:url" content="https://getcryst.al"/>
  <meta property="og:locale" content="en_US"/>
</svelte:head>

<page>
  <section>
    <Feature reverse={false}
	     subtext="Beautiful"
	     subtext_color="{onyxFeatureColour}"
	     header="Onyx built-in"
	     content="Install Crystal with its in-house desktop experience, a custom GNOME session with a familiar layout. Or choose your favourite!">
      {#if isDark}
	<img src="/onyx-dark.webp" alt="The onyx desktop environment, with the jade installer opened" width="1920" height="1080"/>
      {:else}
	<img src="/onyx-light.webp" alt="The onyx desktop environment, with the jade installer opened" width="1920" height="1080"/>
      {/if}
    </Feature>
  </section>
  <section>
    <Feature reverse={true}
	     subtext="Buttery"
	     subtext_color="{btrfsFeatureColour}"
	     header="Automatic Backups"
	     content="Backup and Restore your system. Easily boot into BTRFS snapshots.">
      <img src="/timeshift-snapshots.webp" alt="timeshift" width="1920" height="1080"/>
    </Feature>
  </section>
  <section>
    <Feature reverse={false}
	     subtext="Rusty Quartz?"
	     subtext_color="{ameFeatureColour}"
	     header="Amethyst"
	     content="Amethyst is a fast, efficient and lightweight AUR helper and Pacman wrapper. Made for Crystal, compatible with any Arch-based Linux distribution.">
      <AmeOutput/>
    </Feature>
  </section>
</page>

<style lang="scss">
  @use "sass:color";
  page {
    margin: 0;
    padding: 0;
    & section {
      width: 100%;

      &#welcome {
	& * {
	  text-align: center;
	}
      }

      & img {
	  border-radius: .75rem;
	  max-width: 100%;
	  height: auto;

	  box-shadow: 0 1px 4px 1px color.change(black, $alpha: 0.13),
		      0 1px 10px 5px color.change(black, $alpha: 0.09),
		      0 3px 16px 8px color.change(black, $alpha: 0.04),
		      0 0 0 1px color.change(black, $alpha: 0.05);

      }
    }
  }
</style>
